import { NetworkInterface } from '../definitions';
export declare const ERROR_NETWORK_ADDRESS_NOT_AVAIL = "NETWORK_ADDRESS_NOT_AVAIL";
export declare function getExternalIPv4Interfaces(): NetworkInterface[];
export declare function findClosestOpenPort(port: number, host?: string): Promise<number>;
export declare function isPortAvailable(port: number, host?: string): Promise<boolean>;
/**
 * Continuously attempt TCP connections.
 *
 * By default, this function will only ever resolve once a host is connectable.
 * This behavior can be changed with the `timeout` option, which resolves with
 * `false` if the timeout is reached.
 *
 * @param host The host to connect to.
 * @param port The port to connect to.
 * @param options.timeout Optionally define a timeout, in milliseconds.
 */
export declare function isHostConnectable(host: string, port: number, { timeout }?: {
    timeout?: number;
}): Promise<boolean>;
